package com.fp.persistence.pgeneral.gene;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import javax.persistence.Version;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEFREQUENCY*/
@Entity(name="TgeneFrequency")
@Table(name="TGENEFREQUENCY")
public class TgeneFrequency extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneFrequency
*/
@Id
@Column(name="FRECQENCYCODE" ,nullable=false, updatable=false)
private Integer pk;
@Version
@Column(name="RECORDVERSION", nullable=true)

/**
* Optimistic locking del registro
*/
private Integer recordversion;

@Column(name="DAYS", nullable=false)

/**
* Numero de dias del cliclo diario 1 dia, mensula 30 dias
*/
private Integer days;

@Column(name="DESCRIPTION", nullable=false)

/**
* Descripcion de la frecuencia
*/
private String description;

/**Contructor por defecto*/
public TgeneFrequency(){
}
/**Contructor de TgeneFrequency
@param pPk Clave Primaria del entity
@param pDays Numero de dias del cliclo diario 1 dia, mensula 30 dias
@param pDescription Descripcion de la frecuencia
*/
public TgeneFrequency(Integer pPk,Integer pDays,String pDescription){
 this();
 pk=pPk;
 days=pDays;
 description=pDescription;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneFrequency
*/
public static TgeneFrequency find(EntityManager pEntityManager,Object pKey) throws Exception{
    TgeneFrequency obj = pEntityManager.find(TgeneFrequency.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneFrequency
@return El objeto que referencia a la Clave primaria de TgeneFrequency
*/
public Integer getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneFrequency
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneFrequency
*/
public void setPk(Integer pPk){
  pk=pPk;
}
/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

/**Obtiene el valor de days
@return valor de days*/
public Integer getDays(){
  return days;
}
/**Fija el valor de days
@param pDays nuevo Valor de days*/
public void setDays(Integer pDays){
  days=pDays;
}

/**Obtiene el valor de description
@return valor de description*/
public String getDescription(){
  return description;
}
/**Fija el valor de description
@param pDescription nuevo Valor de description*/
public void setDescription(String pDescription){
  description=pDescription;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneFrequency))return false;
    TgeneFrequency that = (TgeneFrequency) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneFrequency
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneFrequency
*/
public Object createInstance(){
 TgeneFrequency instance=new TgeneFrequency();	
 return instance;
}
/**Clona la entidad TgeneFrequency
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneFrequency p=(TgeneFrequency)this.clone();
  return p;
}
}
